(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('@ecubed/ng-foundations', ['exports', '@angular/core'], factory) :
    (factory((global.ecubed = global.ecubed || {}, global.ecubed['ng-foundations'] = {}),global.ng.core));
}(this, (function (exports,core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgFoundationsModule = /** @class */ (function () {
        function NgFoundationsModule() {
        }
        NgFoundationsModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [],
                        imports: [],
                        exports: []
                    },] }
        ];
        return NgFoundationsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template TKey, TValue
     */
    var /**
     * @template TKey, TValue
     */ KeyValuePair = /** @class */ (function () {
        function KeyValuePair(key, value) {
            this.key = undefined;
            this.value = undefined;
            this.key = key;
            this.value = value;
        }
        return KeyValuePair;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ArrayTools = /** @class */ (function () {
        function ArrayTools() {
        }
        /**
         * @template T
         * @param {?} array
         * @param {?} criteria
         * @return {?}
         */
        ArrayTools.filter = /**
         * @template T
         * @param {?} array
         * @param {?} criteria
         * @return {?}
         */
            function (array, criteria) {
                /** @type {?} */
                var filtered = [];
                for (var i = 0; i < array.length; i++) {
                    if (criteria(array[i])) {
                        filtered.push(array[i]);
                    }
                }
                return filtered;
            };
        /**
         * @template T
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
        ArrayTools.delete = /**
         * @template T
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
            function (item, array) {
                /** @type {?} */
                var index = array.indexOf(item);
                if (index >= 0) {
                    array.splice(index, 1);
                }
            };
        /**
         * @template T
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
        ArrayTools.add = /**
         * @template T
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
            function (item, array) {
                array.push(item);
            };
        /**
         * @template T
         * @param {?} array
         * @return {?}
         */
        ArrayTools.clear = /**
         * @template T
         * @param {?} array
         * @return {?}
         */
            function (array) {
                array.splice(0, array.length);
            };
        /**
         * @template T
         * @param {?} index
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
        ArrayTools.insertAfter = /**
         * @template T
         * @param {?} index
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
            function (index, item, array) {
                if ((index >= 0) && (index < array.length)) {
                    array.splice(index, 0, item);
                }
            };
        /**
         * @template T
         * @param {?} index
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
        ArrayTools.insertBefore = /**
         * @template T
         * @param {?} index
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
            function (index, item, array) {
                if ((index >= 1) && (index < array.length)) {
                    array.splice(index - 1, 0, item);
                }
            };
        /**
         * @template T
         * @param {?} firstArray
         * @param {?} secondArray
         * @return {?}
         */
        ArrayTools.anyOfFirstIsInSecond = /**
         * @template T
         * @param {?} firstArray
         * @param {?} secondArray
         * @return {?}
         */
            function (firstArray, secondArray) {
                for (var i = 0; i < firstArray.length; i++) {
                    if (secondArray.indexOf(firstArray[i]) > -1) {
                        return true;
                    }
                }
                return false;
            };
        /**
         * @template T
         * @param {?} firstArray
         * @param {?} secondArray
         * @return {?}
         */
        ArrayTools.allOfFirstIsInSecond = /**
         * @template T
         * @param {?} firstArray
         * @param {?} secondArray
         * @return {?}
         */
            function (firstArray, secondArray) {
                for (var i = 0; i < firstArray.length; i++) {
                    if (secondArray.indexOf(firstArray[i]) === -1) {
                        return false;
                    }
                }
                return true;
            };
        /**
         * @template T
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
        ArrayTools.canMoveUp = /**
         * @template T
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
            function (item, array) {
                return (array.indexOf(item) > 0);
            };
        /**
         * @template T
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
        ArrayTools.canMoveDown = /**
         * @template T
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
            function (item, array) {
                return (array.indexOf(item) < array.length - 1);
            };
        /**
         * @template T
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
        ArrayTools.moveUp = /**
         * @template T
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
            function (item, array) {
                if (this.canMoveUp(item, array)) {
                    /** @type {?} */
                    var index = array.indexOf(item);
                    this.delete(item, array);
                    this.insertAfter(index - 1, item, array);
                }
            };
        /**
         * @template T
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
        ArrayTools.moveDown = /**
         * @template T
         * @param {?} item
         * @param {?} array
         * @return {?}
         */
            function (item, array) {
                if (this.canMoveDown(item, array)) {
                    /** @type {?} */
                    var index = array.indexOf(item);
                    this.delete(item, array);
                    if (index === array.length - 1) {
                        array.push(item);
                    }
                    else {
                        this.insertAfter(index + 1, item, array);
                    }
                }
            };
        return ArrayTools;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template TKey, TValue
     */
    var /**
     * @template TKey, TValue
     */ KeyValuePairArray = /** @class */ (function (_super) {
        __extends(KeyValuePairArray, _super);
        function KeyValuePairArray(items) {
            return _super.apply(this, __spread(items)) || this;
        }
        /**
         * @template TKey, TValue
         * @return {?}
         */
        KeyValuePairArray.create = /**
         * @template TKey, TValue
         * @return {?}
         */
            function () {
                return Object.create(KeyValuePairArray.prototype);
            };
        /**
         * @param {?} key
         * @return {?}
         */
        KeyValuePairArray.prototype.findByKey = /**
         * @param {?} key
         * @return {?}
         */
            function (key) {
                /** @type {?} */
                var matches = ArrayTools.filter(this, function (item) { return item.key === key; });
                if (matches.length === 0) {
                    return null;
                }
                return matches[0].value;
            };
        /**
         * @param {?} key
         * @param {?} value
         * @return {?}
         */
        KeyValuePairArray.prototype.add = /**
         * @param {?} key
         * @param {?} value
         * @return {?}
         */
            function (key, value) {
                /** @type {?} */
                var match = this.findByKey(key);
                if (match === null) {
                    this.push(new KeyValuePair(key, value));
                }
            };
        /**
         * @param {?} keyValuePair
         * @return {?}
         */
        KeyValuePairArray.prototype.addKeyValuePair = /**
         * @param {?} keyValuePair
         * @return {?}
         */
            function (keyValuePair) {
                /** @type {?} */
                var match = this.findByKey(keyValuePair.key);
                if (match === null) {
                    this.push(keyValuePair);
                }
            };
        /**
         * @param {?} key
         * @return {?}
         */
        KeyValuePairArray.prototype.remove = /**
         * @param {?} key
         * @return {?}
         */
            function (key) {
                /** @type {?} */
                var match = ArrayTools.filter(this, function (kvp) { return kvp.key === key; });
                if ((match !== null) && (match.length > 0)) {
                    ArrayTools.delete(match[0], this);
                }
            };
        return KeyValuePairArray;
    }(Array));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ObjectTools = /** @class */ (function () {
        function ObjectTools() {
        }
        /**
         * @param {?} obj
         * @return {?}
         */
        ObjectTools.cloneObject = /**
         * @param {?} obj
         * @return {?}
         */
            function (obj) {
                return JSON.parse(JSON.stringify(obj));
            };
        /**
         * @template T
         * @param {?} obj
         * @return {?}
         */
        ObjectTools.regardAs = /**
         * @template T
         * @param {?} obj
         * @return {?}
         */
            function (obj) {
                return ( /** @type {?} */(obj));
            };
        return ObjectTools;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NgFoundationsModule = NgFoundationsModule;
    exports.KeyValuePair = KeyValuePair;
    exports.ArrayTools = ArrayTools;
    exports.KeyValuePairArray = KeyValuePairArray;
    exports.ObjectTools = ObjectTools;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ecubed-ng-foundations.umd.js.map