import { NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgFoundationsModule {
}
NgFoundationsModule.decorators = [
    { type: NgModule, args: [{
                declarations: [],
                imports: [],
                exports: []
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template TKey, TValue
 */
class KeyValuePair {
    /**
     * @param {?} key
     * @param {?} value
     */
    constructor(key, value) {
        this.key = undefined;
        this.value = undefined;
        this.key = key;
        this.value = value;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ArrayTools {
    /**
     * @template T
     * @param {?} array
     * @param {?} criteria
     * @return {?}
     */
    static filter(array, criteria) {
        /** @type {?} */
        const filtered = [];
        for (let i = 0; i < array.length; i++) {
            if (criteria(array[i])) {
                filtered.push(array[i]);
            }
        }
        return filtered;
    }
    /**
     * @template T
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static delete(item, array) {
        /** @type {?} */
        const index = array.indexOf(item);
        if (index >= 0) {
            array.splice(index, 1);
        }
    }
    /**
     * @template T
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static add(item, array) {
        array.push(item);
    }
    /**
     * @template T
     * @param {?} array
     * @return {?}
     */
    static clear(array) {
        array.splice(0, array.length);
    }
    /**
     * @template T
     * @param {?} index
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static insertAfter(index, item, array) {
        if ((index >= 0) && (index < array.length)) {
            array.splice(index, 0, item);
        }
    }
    /**
     * @template T
     * @param {?} index
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static insertBefore(index, item, array) {
        if ((index >= 1) && (index < array.length)) {
            array.splice(index - 1, 0, item);
        }
    }
    /**
     * @template T
     * @param {?} firstArray
     * @param {?} secondArray
     * @return {?}
     */
    static anyOfFirstIsInSecond(firstArray, secondArray) {
        for (let i = 0; i < firstArray.length; i++) {
            if (secondArray.indexOf(firstArray[i]) > -1) {
                return true;
            }
        }
        return false;
    }
    /**
     * @template T
     * @param {?} firstArray
     * @param {?} secondArray
     * @return {?}
     */
    static allOfFirstIsInSecond(firstArray, secondArray) {
        for (let i = 0; i < firstArray.length; i++) {
            if (secondArray.indexOf(firstArray[i]) === -1) {
                return false;
            }
        }
        return true;
    }
    /**
     * @template T
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static canMoveUp(item, array) {
        return (array.indexOf(item) > 0);
    }
    /**
     * @template T
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static canMoveDown(item, array) {
        return (array.indexOf(item) < array.length - 1);
    }
    /**
     * @template T
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static moveUp(item, array) {
        if (this.canMoveUp(item, array)) {
            /** @type {?} */
            const index = array.indexOf(item);
            this.delete(item, array);
            this.insertAfter(index - 1, item, array);
        }
    }
    /**
     * @template T
     * @param {?} item
     * @param {?} array
     * @return {?}
     */
    static moveDown(item, array) {
        if (this.canMoveDown(item, array)) {
            /** @type {?} */
            const index = array.indexOf(item);
            this.delete(item, array);
            if (index === array.length - 1) {
                array.push(item);
            }
            else {
                this.insertAfter(index + 1, item, array);
            }
        }
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template TKey, TValue
 */
class KeyValuePairArray extends Array {
    /**
     * @private
     * @param {?=} items
     */
    constructor(items) {
        super(...items);
    }
    /**
     * @template TKey, TValue
     * @return {?}
     */
    static create() {
        return Object.create(KeyValuePairArray.prototype);
    }
    /**
     * @param {?} key
     * @return {?}
     */
    findByKey(key) {
        /** @type {?} */
        const matches = ArrayTools.filter(this, (item) => item.key === key);
        if (matches.length === 0) {
            return null;
        }
        return matches[0].value;
    }
    /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    add(key, value) {
        /** @type {?} */
        const match = this.findByKey(key);
        if (match === null) {
            this.push(new KeyValuePair(key, value));
        }
    }
    /**
     * @param {?} keyValuePair
     * @return {?}
     */
    addKeyValuePair(keyValuePair) {
        /** @type {?} */
        const match = this.findByKey(keyValuePair.key);
        if (match === null) {
            this.push(keyValuePair);
        }
    }
    /**
     * @param {?} key
     * @return {?}
     */
    remove(key) {
        /** @type {?} */
        const match = ArrayTools.filter(this, kvp => kvp.key === key);
        if ((match !== null) && (match.length > 0)) {
            ArrayTools.delete(match[0], this);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ObjectTools {
    /**
     * @param {?} obj
     * @return {?}
     */
    static cloneObject(obj) {
        return JSON.parse(JSON.stringify(obj));
    }
    /**
     * @template T
     * @param {?} obj
     * @return {?}
     */
    static regardAs(obj) {
        return (/** @type {?} */ (obj));
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgFoundationsModule, KeyValuePair, ArrayTools, KeyValuePairArray, ObjectTools };

//# sourceMappingURL=ecubed-ng-foundations.js.map